// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// Application application
//
// swagger:model Application
type Application struct {

	// application name
	ApplicationName string `json:"applicationName,omitempty"`

	// application resources
	ApplicationResources uint32 `json:"applicationResources,omitempty"`

	// application type
	ApplicationType ApplicationType `json:"applicationType,omitempty"`

	// cis docker benchmark result count per level
	CisDockerBenchmarkResults []*CISDockerBenchmarkLevelCount `json:"cisDockerBenchmarkResults"`

	// environments
	Environments []string `json:"environments"`

	// id
	ID string `json:"id,omitempty"`

	// labels
	Labels []string `json:"labels"`

	// packages
	Packages uint32 `json:"packages,omitempty"`

	// vulnerability count per severity
	Vulnerabilities []*VulnerabilityCount `json:"vulnerabilities"`
}

// Validate validates this application
func (m *Application) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateApplicationType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCisDockerBenchmarkResults(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVulnerabilities(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Application) validateApplicationType(formats strfmt.Registry) error {
	if swag.IsZero(m.ApplicationType) { // not required
		return nil
	}

	if err := m.ApplicationType.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("applicationType")
		}
		return err
	}

	return nil
}

func (m *Application) validateCisDockerBenchmarkResults(formats strfmt.Registry) error {
	if swag.IsZero(m.CisDockerBenchmarkResults) { // not required
		return nil
	}

	for i := 0; i < len(m.CisDockerBenchmarkResults); i++ {
		if swag.IsZero(m.CisDockerBenchmarkResults[i]) { // not required
			continue
		}

		if m.CisDockerBenchmarkResults[i] != nil {
			if err := m.CisDockerBenchmarkResults[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("cisDockerBenchmarkResults" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Application) validateVulnerabilities(formats strfmt.Registry) error {
	if swag.IsZero(m.Vulnerabilities) { // not required
		return nil
	}

	for i := 0; i < len(m.Vulnerabilities); i++ {
		if swag.IsZero(m.Vulnerabilities[i]) { // not required
			continue
		}

		if m.Vulnerabilities[i] != nil {
			if err := m.Vulnerabilities[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("vulnerabilities" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this application based on the context it is used
func (m *Application) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateApplicationType(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCisDockerBenchmarkResults(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVulnerabilities(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *Application) contextValidateApplicationType(ctx context.Context, formats strfmt.Registry) error {

	if err := m.ApplicationType.ContextValidate(ctx, formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("applicationType")
		}
		return err
	}

	return nil
}

func (m *Application) contextValidateCisDockerBenchmarkResults(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.CisDockerBenchmarkResults); i++ {

		if m.CisDockerBenchmarkResults[i] != nil {
			if err := m.CisDockerBenchmarkResults[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("cisDockerBenchmarkResults" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *Application) contextValidateVulnerabilities(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Vulnerabilities); i++ {

		if m.Vulnerabilities[i] != nil {
			if err := m.Vulnerabilities[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("vulnerabilities" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *Application) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Application) UnmarshalBinary(b []byte) error {
	var res Application
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
